<?php

defined('_JEXEC') or die('Restricted access');

class pm_paysto extends PaymentRoot{

    var $paystoServers = array(
        '66.226.72.66',
        '66.226.74.225',
        '66.226.74.226',
        '66.226.74.227',
        '66.226.74.228'
    );

    var $conf;

    function __construct()
    {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT `payment_id` FROM `#__jshopping_payment_method` WHERE `payment_class` = "pm_paysto"');
        $payment_method_id = $db->loadResult();
        JModel::addIncludePath(JPATH_COMPONENT.DS.'models');
        $pm_method = JTable::getInstance('paymentMethod', 'jshop');
        $pm_method->load($payment_method_id);
        $this->conf = $pm_method->getConfigs();
    }

    function showPaymentForm($params, $pmconfigs)
    {
        include(dirname(__FILE__)."/paymentform.php");
    }

	
	function showAdminFormParams($params)
    {
	  $array_params = array('PAYSTO_SHOPID', 'PAYSTO_SECRET_KEY', 'transaction_end_status', 'transaction_pending_status', 'transaction_failed_status');
	  foreach ($array_params as $key){
	  	if (!isset($params[$key])) $params[$key] = '';
	  } 
	  $orders = JModel::getInstance('orders', 'JshoppingModel');
      include(dirname(__FILE__)."/adminparamsform.php");	  
	}

	function checkTransaction($pmconfigs, $order, $act)
    {
      return array(1, '');     
	}

	function showEndForm($pmconfigs, $order)
    {
        $cource = 1;
        if(!in_array($order->currency_code, array("RUB", "RUR")))
        {
            $db = JFactory::getDbo();
            $query = 'SELECT `currency_value`
                  FROM `#__jshopping_currencies`
                  WHERE `currency_code_iso`="RUB" OR `currency_code_iso`="RUR"
                  LIMIT 1';
            $db->setQuery($query);
            $rubCource = $db->loadResult();
            $rubCource = (!empty($rubCource)) ? $rubCource : 1;

            $query = 'SELECT `currency_value`
                  FROM `#__jshopping_currencies`
                  WHERE `currency_code_iso`="'.$order->currency_code.'"
                  LIMIT 1';
            $db->setQuery($query);
            $currencyCource = $db->loadResult();
            $currencyCource = (!empty($currencyCource)) ? $currencyCource : 1;

            $cource = $rubCource/$currencyCource;
        }

		$amount = number_format(floatval($order->order_total*$cource), 2, '.', '');
        $mail = JFactory::getUser()->get('email', '');
		include(dirname(__FILE__)."/endform.php");
	}


    /**
     * Validate signature
     */
    function isValidSignature($hash)
    {
        $crc = $this->getSignature($_POST);

        //exit if no check signature
        if( $hash != $crc)
        {
            return false;
        }

        return true;
    }

    /** callback order function
     * @param $a
     * @param $b
     * @return int
     */
    private function cmp($a, $b)
    {
        return strcasecmp($a, $b);
    }

    /** return md5 signature of POST data
     * @param $data
     * @return string
     */
    private function getSignature($data)
    {
        uksort($data, array($this, "cmp"));

        $sign = '';

        foreach ($data as $k => $v)
        {
            if ($k == 'PAYSTO_MD5')
                continue;

            $sign .= $k . '=' . $v . '&';
        }

        $secret = !empty($this->conf['PAYSTO_SECRET_KEY']) ? $this->conf['PAYSTO_SECRET_KEY'] : '';

        $sign = strtoupper(md5($sign . $secret));

        return $sign;
    }

    /** validate request IP
     * @param $ip
     * @return bool
     */
    function isValidIP($ip)
    {
        return (in_array($ip, $this->paystoServers));
    }

    /**
     * @param $data
     * @param $isValid
     */
    function log($data, $isValid)
    {
        $logFilenameBase = JPATH_BASE.'/logs/jshop_log_pm_paysto';

        $logFile = $logFilenameBase.'.php';
        JLoader::import('joomla.filesystem.file');
        if(!JFile::exists($logFile))
        {
            $dummy = "<?php die(); ?>\n";
            JFile::write($logFile, $dummy);
        }
        else
        {
            if(@filesize($logFile) > 1048756)
            {
                $altLog = $logFilenameBase.'-1.php';
                if(JFile::exists($altLog)) {
                    JFile::delete($altLog);
                }
                JFile::copy($logFile, $altLog);
                JFile::delete($logFile);
                $dummy = "<?php die(); ?>\n";
                JFile::write($logFile, $dummy);
            }
        }
        $logData = JFile::read($logFile);
        if($logData === false) $logData = '';
        $logData .= "\n" . str_repeat('-', 80);
        $pluginName = 'pm_paysto';
        $logData .= $isValid ? 'VALID '.$pluginName.' IPN' : 'INVALID '.$pluginName.' IPN *** FRAUD ATTEMPT OR INVALID NOTIFICATION ***';
        $logData .= "\nDate/time : ".gmdate('Y-m-d H:i:s')." GMT\n\n";

        foreach($data as $key => $value)
        {
            $logData .= '  ' . str_pad($key, 30, ' ') . $value . "\n";
        }

        $logData .= "\n";
        JFile::write($logFile, $logData);
    }
}
?>